; tabstop=8
;
;

	ORG	0E000H

	JP	STARTREAD	; E000
	JP	INIT8251	; E003
	JP	TXDATA		; E006
	JP	READROM		; E009
	JP	ENDREAD		; E00C
	JP	STRHEAD		; E00F
	JP	CMPHEAD		; E012

	ORG	0E020H

MODE8251:
	DB	4FH		; stop=1/parity=none/length=8bit/clock=x64
STATUSFLAG:
	DB	00H		; DSR/BD/FE/OE/PE/TXEMPTY/RXRDY/TXRDY
TXMODE:
	DB	81H		; DSR=on/TxRDY=1
ROMADD:
	DB	00H		; ROM address (BA3-0,A15)
CMPRSLT:
	DB	00H		; compare result

STARTREAD:
	DI

	LD	A,082H
	OUT	(0D3H),A	; port A,C=output  port B=input
	LD	A,0E0H
	OUT	(0D2H),A	; nWE/nOE/nCE/CLK/BA3-0
	LD	A,00H
	OUT	(0D0H),A	; A7-0
	LD	A,09H
	OUT	(0D3H),A	; CLK
	LD	A,08H
	OUT	(0D3H),A	; CLK
	LD	A,00H
	OUT	(0D0H),A	; A15-8

	LD	HL,RS232C_INTVEC
	LD	(0FA04H),HL	; RS232C̊荞݂XLbv
RS232C_INTVEC:
	EI
	RET

ENDREAD:
	di
	ld	a,09bh
	out	(0d3h),a	; port A,B,C=input
	ei
	ret


INIT8251:
	DI
	LD	A,(MODE8251)
	LD	B,A
	LD	A,12H
	OUT	(81H),A		; RTS=off/DTR=on/Tx=Disable/Rx=Disable/Error clear
	LD	A,52H
	OUT	(81H),A		; 8251 Reset
	NOP			; wait
	NOP
	NOP
	NOP
	LD	A,B
	OUT	(81H),A		; 8251 mode set
	LD	A,37H
	OUT	(81H),A		; RTS=on/DTR=on/Tx=Enable/Rx=Ensable/Error clear
	EI
	RET


TXDATA:
	DI
	LD	A,02H
	OUT	(93H),A		; oXNGXgOFF
	LD	A,0DDH
	OUT	(0F0H),A	; 0000H-7FFFH RAM
	LD	HL,0000H
	LD	A,(TXMODE)
	LD	D,A
TX_L1:
	IN	A,(81H)		; get TxRDY & DSR status
	AND	D
	CP	D
	JR	NZ,TX_L1
	LD	A,(HL)
	OUT	(80H),A
	INC	HL
	LD	A,H
	CP	80H
	JR	NZ,TX_L1

TX_END:
	LD	A,011H
	OUT	(0F0H),A	; 0000H-7FFFH BASIC-ROM
	LD	A,03H
	OUT	(93H),A		; oXNGXgON
	EI
	RET



READROM:
	call	STARTREAD

	di


	ld	hl,0000h	; ރAhX
	ld	d,00h		; AhX
	ld	e,00h		; AhX

	ld	a,(ROMADD)
	srl	a
	rr	d		; AhXʁi0x0000/0x8000j

	and	0fh
	or	0e0h
	out	(0d2h),a	;nWE=H/nOCE=H/nCE=H/CLK=L

.lp1:

	ld	a,d
	out	(0d0h),a	; AhX
	ld	a,09h
	out	(0d3h),a	; clk
	ld	a,08h
	out	(0d3h),a	; clk
	ld	a,e
	out	(0d0h),a	; AhX
	inc	de

	ld	a,0ah
	out	(0d3h),a	; nCE=L
	ld	a,0ch
	out	(0d3h),a	; nOE=L

	in	a,(0d1h)
	ld	(hl),a
	inc	hl

	ld	a,0dh
	out	(0d3h),a	; nOE=H
	ld	a,0bh
	out	(0d3h),a	; nCE=H


	ld	a,h
	cp	080h
	jr	nz,.lp1

	ld	a,0ffh
	out	(0d2h),a	; oNAhX/CEn/OE

	ei

	call	ENDREAD

	ret


STRHEAD:
	di

	ld	a,0ddh
	out	(0f0h),a	; 0000H-7FFFH RAM

	ld	bc,010h
	ld	hl,0000h
	ld	de,0dff0h
	ldir

	ld	a,011h
	out	(0f0h),a	; 0000H-7FFFH BASIC-ROM

	ei
	ret


CMPHEAD:
	di
	xor	a
	ld	(CMPRSLT),a

	ld	a,0ddh
	out	(0f0h),a	; 0000H-7FFFH RAM

	ld	b,010h
.lp1:
	ld	hl,0000h
	ld	de,0dff0h
	ld	a,(de)
	cp	(hl)
	jr	nz,.neq
	djnz	.lp1
	jr	.end

.neq:
	ld	a,0ffh
	ld	(CMPRSLT),a

.end:
	ld	a,011h
	out	(0f0h),a	; 0000H-7FFFH BASIC-ROM

	ei
	ret


	END

